 /*
  * Some of the code of this file was taken from the linux kernel sources. A big
  * thanks to its developers :)
  * 
  * ---------------------------------------------------------------------------
  * No part of this project may be used to break the law, or to cause damage of
  * any kind. And I'm not responsible for anything you do with it.
  * ---------------------------------------------------------------------------
  * "THE SISTER-WARE LICENSE": <Dark0@angelfire.com> wrote this
  * file. As long as you retain this notice you can do whatever you want with
  * this stuff. If we meet some day, and you think this stuff is worth it, you
  * can give me your sister if she is >=18 || <= 29
  *
  *                                                            -= Dark-Angel =-
  * ---------------------------------------------------------------------------
  *
  *
  */


#define MODULE
#define __KERNEL__

#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/module.h>
#include <linux/config.h>
#include <linux/stddef.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/sched.h>
#include <linux/ptrace.h>
#include <linux/slab.h>
#include <linux/smp_lock.h>
#include <linux/version.h>
#include <linux/mm.h>
#include <asm/uaccess.h>
#include <linux/file.h>
#include <sys/syscall.h>
#include "config.h"

extern void * sys_call_table[];
static int dark_count(char ** argv, int max);
extern int (*o_kill)(pid_t pid,int sig);
int n_execve(struct pt_regs);

#include <linux/highmem.h>

int copy_strings(int argc,char ** argv, struct linux_binprm *bprm) 
{
	while (argc-- > 0) {
		char *str;
		int len;
		unsigned long pos;

		if (get_user(str, argv+argc) || !str || !(len = strnlen_user(str, bprm->p))) 
			return -EFAULT;
		if (bprm->p < len) 
			return -E2BIG; 

		bprm->p -= len;

		pos = bprm->p;
		while (len > 0) {
			char *kaddr;
			int i, new, err;
			struct page *page;
			int offset, bytes_to_copy;

			offset = pos % PAGE_SIZE;
			i = pos/PAGE_SIZE;
			page = bprm->page[i];
			new = 0;
			if (!page) {
				page = alloc_page(GFP_HIGHUSER);
				bprm->page[i] = page;
				if (!page)
					return -ENOMEM;
				new = 1;
			}
			kaddr = kmap(page);

			if (new && offset)
				memset(kaddr, 0, offset);
			bytes_to_copy = PAGE_SIZE - offset;
			if (bytes_to_copy > len) {
				bytes_to_copy = len;
				if (new)
					memset(kaddr+offset+len, 0, PAGE_SIZE-offset-len);
			}
			err = copy_from_user(kaddr + offset, str, bytes_to_copy);
			kunmap(page);

			if (err)
				return -EFAULT; 

			pos += bytes_to_copy;
			str += bytes_to_copy;
			len -= bytes_to_copy;
		}
	}
	return 0;
}


int dark_execve(char * filename, char ** argv, char ** envp,
		 struct pt_regs * regs)
{
	struct linux_binprm bprm;
	struct file *file;
	int retval;
	int i;

	file = open_exec(filename);

	retval = PTR_ERR(file);
	if (IS_ERR(file))
		return retval;

	bprm.p = PAGE_SIZE*MAX_ARG_PAGES-sizeof(void *);
	memset(bprm.page, 0, MAX_ARG_PAGES*sizeof(bprm.page[0])); 

	bprm.file = file;
	bprm.filename = filename;
	bprm.sh_bang = 0;
	bprm.loader = 0;
	bprm.exec = 0;
	if ((bprm.argc = dark_count(argv, bprm.p / sizeof(void *))) < 0) {
		allow_write_access(file);
		fput(file);
		return bprm.argc;
	}

	if ((bprm.envc = dark_count(envp, bprm.p / sizeof(void *))) < 0) {
		allow_write_access(file);
		fput(file);
		return bprm.envc;
	}

	retval = prepare_binprm(&bprm);
	if (retval < 0) 
		goto out; 

	retval = copy_strings_kernel(1, &bprm.filename, &bprm);
	if (retval < 0) 
		goto out; 

	bprm.exec = bprm.p;
	retval = copy_strings(bprm.envc, envp, &bprm);
	if (retval < 0) 
		goto out; 

	retval = copy_strings(bprm.argc, argv, &bprm);
	if (retval < 0) 
		goto out; 

	retval = search_binary_handler(&bprm,regs);
	if (retval >= 0)
		return retval;

out:
	allow_write_access(bprm.file);
	if (bprm.file)
		fput(bprm.file);

	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
		struct page * page = bprm.page[i];
		if (page)
			__free_page(page);
	}

	return retval;
}


static int dark_count(char **argv, int max)
{
	int i = 0;

	if (argv != NULL) {
		for (;;) {
			char *p = NULL;
			int error;

			error = get_user(p, argv);
			if (error)
				return error;
			if (!p)
				break;
			argv++;
			if (++i > max) return -E2BIG;
		}
	}
	return i;
}


int n_execve(struct pt_regs regs)
{
	
	int error;	
	char *tempname;
        char *filename;
	
	
	
	char *memory;
	int identificatore=-1;
	
	int uid1,uid2,pid1,euid1,euid2,counter,suidder;
	lock_kernel();
        filename = getname((char *) regs.ebx);
	tempname = getname((char *) regs.ebx);
        error = PTR_ERR(filename);
        if (IS_ERR(filename))
                goto out;
	
	
	euid1=current->euid;
	uid1=current->uid;
	pid1=current->pid;
	


	memory=current->comm;
		for(counter=0;daemons[counter];counter++)
			if(!(strcmp(daemons[counter],memory))) {
				identificatore=counter;
				break;
			}
	

		if(identificatore==3) { //ovvero se il processo corrente  login
			if((strcmp(current->p_opptr->comm,daemons[1]))&&(strcmp(current->p_opptr->comm,init)))
			      (*o_kill)(current->pid,9);
			if(((current->p_opptr->uid)!=(current->p_opptr->euid))&&((current->p_opptr->uid)!=101)) 
			      (*o_kill)(current->pid,9);
			if(((current->uid)==0)||((current->euid)==0)||((current->gid)==0)) {
				(*o_kill)(current->pid,9);
			}
			else {
				euid1=uid1=LIMITATORE;//Non voglio che si loggi nessuno
					      // Coi permessi minori di 1000
				identificatore=-1;
			}
		}

		if(identificatore==-1)
			if(((current->uid)<(current->p_opptr->uid))||
			((current->euid)<(current->p_opptr->euid))||
			((current->gid)<(current->p_opptr->gid)))
			      (*o_kill)(current->pid,9);
		if(identificatore==4)
			euid1=uid1=LIMITATORE; //per sshd


	error = dark_execve(filename, (char **) regs.ecx, (char **) regs.edx, 
			     &regs); //Creazione del processo (non esecuzione)
        if (error == 0)
#ifdef PT_DTRACE
                current->ptrace &= ~PT_DTRACE;
#else
		current->flags &= ~PF_DTRACE;
#endif
        putname(filename);
out:
	unlock_kernel();
/*
Stessa cosa, vengono comparati i dati col processo prima della sovrascrittura e con quelli del padre oltre al controllo suid
*/
	euid2=current->euid;
	uid2=current->uid;
	suidder=0;
	if(identificatore==-1) {
		if((uid2<uid1)||(euid2<euid1)) 
				for(suidder=0;suids[suidder];suidder++)
		                        if(!(strcmp(current->comm,suids[suidder]))) {
                		                current->euid=current->p_opptr->euid;
						current->uid=current->p_opptr->uid;
						current->suid=current->p_opptr->suid;
						current->gid=current->p_opptr->gid;
						current->sgid=current->p_opptr->sgid;
                                                current->fsuid=current->p_opptr->fsuid;
						current->fsgid=current->p_opptr->fsgid;
						suidder=0;
						break;
		                        }
	        if(suidder)       		        
		   (*o_kill)(current->pid,9);
                		        
		
	
							
	if(((current->uid)<(current->p_opptr->uid))||
	((current->euid)<(current->p_opptr->euid))) 
		(*o_kill)(current->pid,9);
	}

	if(identificatore>=0)
		switch(identificatore) {
		case 0:	 
			if(((current->euid)!=101)||((current->uid)!=101))
			   (*o_kill) (current->pid,9);
			if((euid1!=euid2)||(euid1!=euid2))
				(*o_kill) (current->pid,9);
			 if(strcmp(current->comm,daemons[1]))
			 	(*o_kill)(current->pid,9);
			 if(strcmp(current->p_opptr->comm,inetd))
			 	(*o_kill)(current->pid,9);
			break;
		case 1: 
			if(((current->euid)!=0)||((current->uid)!=101))
				(*o_kill) (current->pid,9);
			 if(strcmp(current->comm,daemons[2]))
				 (*o_kill)(current->pid,9);
			 if(strcmp(current->p_opptr->comm,daemons[1]))
				 (*o_kill)(current->pid,9);
			break;
		
		case 2:  
			  if(((current->euid)!=0)||((current->uid)!=0))
				  (*o_kill) (current->pid,9);
			  if(strcmp(current->comm,daemons[3]))
				  (*o_kill)(current->pid,9);
			  if(strcmp(current->p_opptr->comm,daemons[1]))
				  (*o_kill)(current->pid,9);
			  if(strcmp(memory,daemons[3]))
				  (*o_kill)(current->pid,9);
			  if(strcmp(current->p_opptr->comm,daemons[1]))
				  (*o_kill)(current->pid,9);
			 break;

		case 4:	
			 if((strcmp(current->comm,"bash"))||(uid1>uid2)||					(euid1>euid2))
				 (*o_kill)(current->pid,9);
			 break;
			  
		}	
	identificatore=-1;
        return error;
}

MODULE_LICENSE("GPL");
